/*
 :
1)  +5
2)   5,      ,  +12
3)      ,    +12
4)    +5
5)  ATmega8      
  

  ATmega8    Fuse-
==================*/


/*Fuse-  ATmega8535:
  0101 1001		high
  1110 1111 	low*/

.include	"m8535def.inc"
.equ	RDY	=PB0
.equ	S12V	=PB1
.equ 	S5V	=PB2
.equ	HL	=PB3

.equ	OE	=PA0
.equ	WR	=PA1
.equ	BS1	=PA2
.equ	XTAL	=PA3
.equ	XA0	=PA4
.equ	XA1	=PA5
.equ	PAGEL	=PA6
.equ	BS2	=PA7

.equ	cmdErase	=0b10000000
.equ	cmdFuse	=0b01000000

/*Fuse- ATmega8:
 (,   
  )*/
.equ	HiFuse	=0b11011001	
.equ	LoFuse	=0b11100001 

.def	tm1	=r16
.def	tm2	=r17
.def	tmp	=r18

.def	dl1	=r20


.def	datrs	=r24
.def	cmdrs	=r25


.CSEG
.org 0
	rjmp	RESET

;===:===

/*     
   Fuse- RESET=0  CKSEL[3:0]<>0b0000*/
SetEmrgPRGmode:
	ldi	tmp,(0<<PAGEL)|(0<<XA1)|(0<<XA0)|(0<<BS1)| (1<<OE)|(1<<WR)
	out	PORTA,tmp
	rcall	Delay

	ldi	tmp,(1<<RDY)|(1<<S5V)|(1<<S12V)
	out	PORTB,tmp
	rcall	Delay
	ret

;===   :===
SetNeutralMode:
	cbi	PORTB,S12V
	rcall	Delay
	cbi	PORTB,S5V
	ret

;===   Lock-:===
xErase:
	sbi	PORTA,XA1	;XA1:XA0=10,BS1=0
	cbi	PORTA,XA0
	cbi	PORTA,BS1
	ldi	tmp,cmdErase
	out	PORTC,tmp	
	rcall	PlsXTAL
	rcall	PlsWr
xEr1:	wdr
	sbis	PINB,RDY
	rjmp	xEr1
	ret

;===  Fuse-:===
ProgFuse:
	rcall	SetEmrgPrgMode

	rcall	xErase	;   Lock-

;===  Fuse-:===
;  0100 0000:
	sbi	PORTA,XA1	;XA1:XA0=10,BS1=0
	cbi	PORTA,XA0
	cbi	PORTA,BS1
	cbi	PORTA,BS2
	ldi	tmp,cmdFuse
	out	PORTC,tmp	
	rcall	PlsXTAL
	cbi	PORTA,XA1
	
;    Fuse-		
	cbi	PORTA,XA1
	sbi	PORTA,XA0
	ldi	tmp,LoFuse 
	out	PORTC,tmp
	rcall	PlsXTAL

; :
	cbi	PORTA,BS2
	cbi	PORTA,BS1
	rcall	PlsWr
WtRdy:wdr
	sbis	PINB,RDY
	rjmp	WtRdy
	rcall	Delay

;===  Fuse-:===
;  0100 0000:

	sbi	PORTA,XA1	;XA1:XA0=10,BS1=0
	cbi	PORTA,XA0
	cbi	PORTA,BS1
	cbi	PORTA,BS2
	ldi	tmp,cmdFuse
	out	PORTC,tmp	
	rcall	PlsXTAL
	cbi	PORTA,XA1
	
;    Fuse-		
	cbi	PORTA,XA1
	sbi	PORTA,XA0
	ldi	tmp,HiFuse
	out	PORTC,tmp
	;out	PORTC,dataHiFuse
	rcall	PlsXTAL

; :
	cbi	PORTA,BS2
	sbi	PORTA,BS1
	rcall	PlsWr
WRdy:	wdr
	sbis	PINB,RDY
	rjmp	WRdy
	rcall	Delay

	cbi	PORTA,BS1

	rcall	SetNeutralMode
	ret

;=== 140us:=== 
Delay:
	ldi	dl1,255
Del1:	wdr
	dec	dl1
	brne	Del1
	ret

;===   XTAL1:===
PlsXTAL:
	rcall	Delay
	sbi	PORTA,XTAL
	rcall	Delay
	cbi	PORTA,XTAL
	rcall	Delay
	ret

;===   Wr:===
PlsWr:
	cbi	PORTA,Wr
	rcall	Delay
	sbi	PORTA,Wr
	rcall	Delay
	ret

;===  1:===
d1s:	ldi	tmp,38
	wdr
d1_1:ldi	tm2,255
d1_2:ldi	tm1,255
d1_3:dec	tm1
	brne	d1_3
	dec	tm2
	brne	d1_2
	dec	tmp	
	brne	d1_1
	ret


;=== :===
Reset:ldi	tmp,(1<<WDE)|(1<<WDCE)
	out	WDTCR,tmp
	ldi	tmp,(1<<WDE)|(1<<WDP2)|(1<<WDP1)|(1<<WDP0)
	out	WDTCR,tmp
	wdr

	ldi	tmp,HIGH(RAMEND)	; 
	out	SPH,tmp		
	ldi	tmp,LOW(RAMEND)	
	out	SPL,tmp		

	ldi	tmp,$ff
	out	DDRA,tmp
	out	DDRC,tmp
	out	DDRD,tmp
	out	PORTD,tmp
	clr	tmp
	out	PORTC,tmp
	ldi	tmp,(1<<XA1)|(1<<XA0)
	out	PORTA,tmp


	ldi	tmp,~(1<<RDY)
	out	DDRB,tmp
	ldi	tmp,1<<RDY
	out	PORTB,tmp


	sbi	PORTB,HL
	rcall	d1s
	cbi	PORTB,HL
	rcall	d1s
	sbi	PORTB,HL
	rcall	d1s
	cbi	PORTB,HL
	rcall	d1s
	sbi	PORTB,HL
	rcall	d1s
	cbi	PORTB,HL

	rcall	ProgFuse

;=== :===
cycle:wdr
	rjmp	cycle
	
